import numpy as np
import scipy as sp
import os
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit

##They are Sigma+ ##
directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/PLE at Different Magnetic Fields/1000_Gauss/'

### D1
Freq_x = os.path.join(directory, 'D1_3uW_1000Gauss_5sx3_QWP_1282022_12_20_12_42_run_1_THz.txt')
Counts_y = os.path.join(directory, 'D1_3uW_1000Gauss_5sx3_QWP_1282022_12_20_12_42_run_1_Counts.txt')
Power_z = os.path.join(directory, 'D1_3uW_1000Gauss_5sx3_QWP_1282022_12_20_12_42_run_1_uW.txt')

### D2
Freq_x2 = os.path.join(directory, 'D2_3uW_1000Gauss_5sx3_QWP_1282022_12_20_13_38_run_1_THz.txt')
Counts_y2 = os.path.join(directory, 'D2_3uW_1000Gauss_5sx3_QWP_1282022_12_20_13_38_run_1_Counts.txt')
Power_z2 = os.path.join(directory, 'D2_3uW_1000Gauss_5sx3_QWP_1282022_12_20_13_38_run_1_uW.txt')

### D3
Freq_x3 = os.path.join(directory, 'D3_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_11_run_1_THz.txt')
Counts_y3 = os.path.join(directory, 'D3_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_11_run_1_Counts.txt')
Power_z3 = os.path.join(directory, 'D3_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_11_run_1_uW.txt')

### D4
Freq_x4 = os.path.join(directory, 'D4_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_50_run_1_THz.txt')
Counts_y4 = os.path.join(directory, 'D4_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_50_run_1_Counts.txt')
Power_z4 = os.path.join(directory, 'D4_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_50_run_1_uW.txt')

### D5
Freq_x5 = os.path.join(directory, 'D5_3uW_1000Gauss_5sx3_QWP_1282022_12_20_15_29_run_1_THz.txt')
Counts_y5 = os.path.join(directory, 'D5_3uW_1000Gauss_5sx3_QWP_1282022_12_20_15_29_run_1_Counts.txt')
Power_z5 = os.path.join(directory, 'D5_3uW_1000Gauss_5sx3_QWP_1282022_12_20_15_29_run_1_uW.txt')

### D6
Freq_x6 = os.path.join(directory, 'D6_3uW_1000Gauss_5sx3_QWP_1282022_12_20_16_04_run_1_THz.txt')
Counts_y6 = os.path.join(directory, 'D6_3uW_1000Gauss_5sx3_QWP_1282022_12_20_16_04_run_1_Counts.txt')
Power_z6 = os.path.join(directory, 'D6_3uW_1000Gauss_5sx3_QWP_1282022_12_20_16_04_run_1_uW.txt')

### Load the data
x1 = np.loadtxt(Freq_x)
y1 = np.loadtxt(Counts_y)
#
x2 = np.loadtxt(Freq_x2)
y2 = np.loadtxt(Counts_y2)
#
x3 = np.loadtxt(Freq_x3)
y3 = np.loadtxt(Counts_y3)
#
x4 = np.loadtxt(Freq_x4)
y4 = np.loadtxt(Counts_y4)
#
x5 = np.loadtxt(Freq_x5)
y5 = np.loadtxt(Counts_y5)
#
x6 = np.loadtxt(Freq_x6)
y6 = np.loadtxt(Counts_y6)

### Order the point in both arrays (due to the mode hoping the points are not in order)
ind_1 = np.argsort(x1)
x1 = x1[ind_1]
y1 = y1[ind_1]
###
ind_2 = np.argsort(x2)
x2 = x2[ind_2]
y2 = y2[ind_2]
###
ind_3 = np.argsort(x3)
x3 = x3[ind_3]
y3 = y3[ind_3]
###
ind_4 = np.argsort(x4)
x4 = x4[ind_4]
y4 = y4[ind_4]
###
ind_5 = np.argsort(x5)
x5 = x5[ind_5]
y5 = y5[ind_5]
# ###
ind_6 = np.argsort(x6)
x6 = x6[ind_6]
y6 = y6[ind_6]


### Make the Baseline Zero
# baseline0 = np.mean(y0[0:10])
# y0=y0-baseline0
# baseline = np.mean(y[0:10])
# y=y-baseline
# baseline2 = np.mean(y2[0:10])
# y2=y2-baseline2
# baseline3 = np.mean(y3[0:10])
# y3=y3-baseline3
# baseline4 = np.mean(y4[0:10])
# y4=y4-baseline4
# baseline_5 = np.mean(y_5[0:10])
# y_5=y_5-baseline_5
# baseline_5b = np.mean(y_5b[0:10])
# y_5b=y_5b-baseline_5b
# baseline5 = np.mean(y5[0:10])
# y5=y5-baseline5

# ### Normalize for the power
# y0=y0*1.36364

### Convert Everything in cps (i.e., divide by the integration time)
# y1 =y1/5       ##   File: D1_3uW_1000Gauss_5sx3_QWP_1282022_12_20_12_42_run_1_Counts
# y2 =y2/5       ##   File: D2_3uW_1000Gauss_5sx3_QWP_1282022_12_20_13_38_run_1_Counts
# y3 =y3/5       ##   File: D3_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_11_run_1_Counts
# y4 =y4/5       ##   File: D4_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_50_run_1_Counts
# y5=y5/5        ##  File:  D5_3uW_1000Gauss_5sx3_QWP_1282022_12_20_15_29_run_1_Counts
# y6=y6/5        ##   File:  D6_3uW_1000Gauss_5sx3_QWP_1282022_12_20_16_04_run_1_Counts

### Define Fitting/Plotting Range
x_range_1 = x1[(x1>234.420) & (x1<234.430)]
y_range_1 = y1[(x1>234.420) & (x1<234.430)]
x_range_2 = x2[(x2>234.420) & (x2<234.430)]
y_range_2 = y2[(x2>234.420) & (x2<234.430)]
x_range_3 = x3[(x3>234.420) & (x3<234.430)]
y_range_3 = y3[(x3>234.420) & (x3<234.430)]
x_range_4 = x4[(x4>234.420) & (x4<234.430)]
y_range_4 = y4[(x4>234.420) & (x4<234.430)]
x_range_5 = x5[(x5>234.420) & (x5<234.430)]
y_range_5 = y5[(x5>234.420) & (x5<234.430)]
x_range_6 = x6[(x6>234.420) & (x6<234.430)]
y_range_6 = y6[(x6>234.420) & (x6<234.430)]

# ### Error on the counts - Square root of the Counts
# y1_err = np.sqrt(y_range_1)
# y2_err = np.sqrt(y_range_2)
# y3_err = np.sqrt(y_range_3)
# y4_err = np.sqrt(y_range_4)
# y5_err = np.sqrt(y_range_5)
# y6_err = np.sqrt(y_range_6)


### Calclualte error first, then convert error in cps (i.e., divide by 5s - see data names)###
y1_err = np.sqrt(y_range_1)/5      ##File: D1_3uW_1000Gauss_5sx3_QWP_1282022_12_20_12_42_run_1_Counts
y2_err = np.sqrt(y_range_2)/5      ##File: D2_3uW_1000Gauss_5sx3_QWP_1282022_12_20_13_38_run_1_Counts
y3_err = np.sqrt(y_range_3)/5      ##File: D3_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_11_run_1_Counts
y4_err = np.sqrt(y_range_4)/5      ##File: D4_3uW_1000Gauss_5sx3_QWP_1282022_12_20_14_50_run_1_Counts
y5_err = np.sqrt(y_range_5)/5      ##File: D5_3uW_1000Gauss_5sx3_QWP_1282022_12_20_15_29_run_1_Counts
y6_err = np.sqrt(y_range_6)/5      ##File: D6_3uW_1000Gauss_5sx3_QWP_1282022_12_20_16_04_run_1_Counts

### Covnert range in cps

y_range_1 = y_range_1/5
y_range_2 = y_range_2/5
y_range_3 = y_range_3/5
y_range_4 = y_range_4/5
y_range_5 = y_range_5/5
y_range_6 = y_range_6/5


### Plot Data
#plt.plot(x_range1, y_range1,'o', label='D1')        #color='blue',
plt.errorbar(x_range_1, y_range_1, yerr=y1_err, marker='.',label='D1', color='royalblue',linestyle='None')
#
#plt.plot(x_range2, y_range2,'o', label='D2')        #color='red',
plt.errorbar(x_range_2, y_range_2, yerr=y2_err, marker='.',label='D2', color='navy', linestyle='None')
#
#plt.plot(x_range3, y_range3,'o', label='D3')        #color='green',
plt.errorbar(x_range_3, y_range_3, yerr=y3_err, marker='.',label='D3',color='orange', linestyle='None')
#
#plt.plot(x_range4, y_range4,'o', label='D4')        #color='black',
plt.errorbar(x_range_4, y_range_4, yerr=y4_err, marker='.',label='D4',color='limegreen', linestyle='None')
#
#plt.plot(x_range_5, y_range_5,'o',label='D_5')   #color='gray',
plt.errorbar(x_range_5, y_range_5, yerr=y5_err, marker='.',label='D5',color='red', linestyle='None')
# #
# #plt.plot(x_range_5, y_range_5,'o',label='D_5')   #color='gray',
plt.errorbar(x_range_6, y_range_6, yerr=y6_err, marker='.',label='D6',color='brown',linestyle='None')

#plt.axis([234.4227, 234.4295,400, 1500])

################
### Fittings ###
################

### Define your parameters - Initial Guess

### D_1
#x_1 = 234.422
amp_1 = 170    # counts
y0_1 = 42
cen_1 = 234.42567  # THz
wid_1 = 0.0001   # THz
#
### D_2
amp_2 = 110    # counts
y0_2 = 42
cen_2 = 234.42593  # THz
wid_2 = 0.0001   # THz
#
### D_3
amp_3 = 110    # counts
y0_3 = 42
cen_3 = 234.42589  # THz
wid_3 = 0.0001   # THz
#
### D_4
amp_4 = 120    # counts
y0_4 = 46
cen_4 = 234.4259  # THz
wid_4 = 0.0001   # THz
#
### D_5
amp_5 = 100    # counts
y0_5 = 52
cen_5 = 234.425966  # THz
wid_5 = 0.0001   # THz
#
### D_6
amp_6 = 134    # counts
y0_6 = 51
cen_6 = 234.425966  # THz
wid_6 = 0.0001   # THz

### Define the Fitting function
def _1Lorentzian_1(x, amp_1, cen_1, wid_1):
    return y0_1 + amp_1 * wid_1 / ((x - cen_1) ** 2 + wid_1 ** 2)

def _1Lorentzian_2(x, amp_2, cen_2, wid_2):
    return y0_2 + amp_2 * wid_2 / ((x - cen_2) ** 2 + wid_2 ** 2)

def _1Lorentzian_3(x, amp_3, cen_3, wid_3):
    return y0_3 + amp_3 * wid_3 / ((x - cen_3) ** 2 + wid_3 ** 2)

def _1Lorentzian_4(x, amp_4, cen_4, wid_4):
    return y0_4 + amp_4 * wid_4 / ((x - cen_4) ** 2 + wid_4 ** 2)

def _1Lorentzian_5(x, amp_5, cen_5, wid_5):
    return y0_5 + amp_5 * wid_5 / ((x - cen_5) ** 2 + wid_5 ** 2)

def _1Lorentzian_6(x, amp_6, cen_6, wid_6):
    return y0_6 + amp_6 * wid_6 / ((x - cen_6) ** 2 + wid_6 ** 2)

popt_lorentzian_1, pcov_lorentzian_1 = sp.optimize.curve_fit(_1Lorentzian_1, x_range_1, y_range_1, p0=[amp_1, cen_1, wid_1])
popt_lorentzian_2, pcov_lorentzian_2 = sp.optimize.curve_fit(_1Lorentzian_2, x_range_2, y_range_2, p0=[amp_2, cen_2, wid_2])
popt_lorentzian_3, pcov_lorentzian_3 = sp.optimize.curve_fit(_1Lorentzian_3, x_range_3, y_range_3, p0=[amp_3, cen_3, wid_3])
popt_lorentzian_4, pcov_lorentzian_4 = sp.optimize.curve_fit(_1Lorentzian_4, x_range_4, y_range_4, p0=[amp_4, cen_4, wid_4])
popt_lorentzian_5, pcov_lorentzian_5 = sp.optimize.curve_fit(_1Lorentzian_5, x_range_5, y_range_5, p0=[amp_5, cen_5, wid_5])
popt_lorentzian_6, pcov_lorentzian_6 = sp.optimize.curve_fit(_1Lorentzian_6, x_range_6, y_range_6, p0=[amp_6, cen_6, wid_6])

### Error
perr_lorentz_1 = np.sqrt(np.diag(pcov_lorentzian_1))
perr_lorentz_2 = np.sqrt(np.diag(pcov_lorentzian_2))
perr_lorentz_3 = np.sqrt(np.diag(pcov_lorentzian_3))
perr_lorentz_4 = np.sqrt(np.diag(pcov_lorentzian_4))
perr_lorentz_5 = np.sqrt(np.diag(pcov_lorentzian_5))
perr_lorentz_6 = np.sqrt(np.diag(pcov_lorentzian_6))
###
###
pars1 = popt_lorentzian_1[0:3]
HWHM1 = pars1[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM1 = round(2*HWHM1,2) # FWHM = 2xHWHM in MHz
Center1 = round(pars1[1],6)
#
pars2 = popt_lorentzian_2[0:3]
HWHM2 = pars2[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM2 = round(2*HWHM2,2) # FWHM = 2xHWHM in MHz
Center2 = round(pars2[1],6)
#
pars3 = popt_lorentzian_3[0:3]
HWHM3 = pars3[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM3 = round(2*HWHM3,2) # FWHM = 2xHWHM in MHz
Center3 = round(pars3[1],6)
#
pars4 = popt_lorentzian_4[0:3]
HWHM4 = pars4[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM4 = round(2*HWHM4,2) # FWHM = 2xHWHM in MHz
Center4 = round(pars4[1],6)
#
pars_5 = popt_lorentzian_5[0:3]
HWHM_5 = pars_5[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM_5 = round(2*HWHM_5,2) # FWHM = 2xHWHM in MHz
Center_5 = round(pars_5[1],6)
#
pars_6 = popt_lorentzian_6[0:3]
HWHM_6 = pars_6[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM_6 = round(2*HWHM_6,2) # FWHM = 2xHWHM in MHz
Center_6 = round(pars_6[1],6)

### Optimal Parameters rounded to 2 digits precision
amp_opt1 = popt_lorentzian_1[0]
cen_opt1 = popt_lorentzian_1[1]
wid_opt1 = popt_lorentzian_1[2]
#
amp_opt2 = popt_lorentzian_2[0]
cen_opt2 = popt_lorentzian_2[1]
wid_opt2 = popt_lorentzian_2[2]
#
amp_opt3 = popt_lorentzian_3[0]
cen_opt3 = popt_lorentzian_3[1]
wid_opt3 = popt_lorentzian_3[2]
#
amp_opt4 = popt_lorentzian_4[0]
cen_opt4 = popt_lorentzian_4[1]
wid_opt4 = popt_lorentzian_4[2]
#
amp_opt_5 = popt_lorentzian_5[0]
cen_opt_5 = popt_lorentzian_5[1]
wid_opt_5 = popt_lorentzian_5[2]
#
amp_opt_6 = popt_lorentzian_6[0]
cen_opt_6 = popt_lorentzian_6[1]
wid_opt_6 = popt_lorentzian_6[2]
#
#
### Error of the  Parameters rounded to 2 digits precision
amp_opt_error1 = perr_lorentz_1[0]
cen_opt_error1 = perr_lorentz_1[1]
wid_opt_error1 = perr_lorentz_1[2]
#
amp_opt_error2 = perr_lorentz_2[0]
cen_opt_error2 = perr_lorentz_2[1]
wid_opt_error2 = perr_lorentz_2[2]
#
amp_opt_error3 = perr_lorentz_3[0]
cen_opt_error3 = perr_lorentz_3[1]
wid_opt_error3 = perr_lorentz_3[2]
#
amp_opt_error4 = perr_lorentz_4[0]
cen_opt_error4 = perr_lorentz_4[1]
wid_opt_error4 = perr_lorentz_4[2]
#
amp_opt_error_5 = perr_lorentz_5[0]
cen_opt_error_5 = perr_lorentz_5[1]
wid_opt_error_5 = perr_lorentz_5[2]
# #
amp_opt_error_6 = perr_lorentz_6[0]
cen_opt_error_6 = perr_lorentz_6[1]
wid_opt_error_6 = perr_lorentz_6[2]

### Extract FWHM and Center
HWHM1= round(wid_opt1*10**6,2) # *10**6 to go from THZ to MHz
FWHM1 = round(2*HWHM1,2)
FWHM_err1 = round(2*wid_opt_error1,6)
Center1 = round(cen_opt1,6)
Center_err1 = round(cen_opt_error1,6)
#
HWHM2 = round(wid_opt2*10**6,2)
FWHM2 = round(2*HWHM2,2)
FWHM_err2 = round(2*wid_opt_error2,6)
Center2 = round(cen_opt2,6)
Center_err2 = round(cen_opt_error2,6)
#
HWHM3 = round(wid_opt3*10**6,2)
FWHM3 = round(2*HWHM3,2)
FWHM_err3 = round(2*wid_opt_error3,6)
Center3 = round(cen_opt3,6)
Center_err3 = round(cen_opt_error3,6)
#
HWHM4 = round(wid_opt4*10**6,2)
FWHM4 = round(2*HWHM4,2)
FWHM_err4 = round(2*wid_opt_error4,6)
Center4 = round(cen_opt4,6)
Center_err4 = round(cen_opt_error4,6)
#
HWHM_5 = round(wid_opt_5*10**6,2)
FWHM_5 = round(2*HWHM_5,2)
FWHM_err_5 = round(2*wid_opt_error_5,6)
Center_5 = round(cen_opt_5,6)
Center_err_5 = round(cen_opt_error_5,6)
#
HWHM_6 = round(wid_opt_6*10**6,2)
FWHM_6 = round(2*HWHM_6,2)
FWHM_err_6 = round(2*wid_opt_error_6,6)
Center_6 = round(cen_opt_6,6)
Center_err_6 = round(cen_opt_error_6,6)

Max_Splitting = round((max(Center1,Center2,Center3,Center4,Center_5,Center_6) - min(Center1,Center2,Center3,Center4,Center_5,Center_6))*10**6,0) # from THz to MHz
#round((Center - Center2)*10**6,0) # from THz to MHz

# ####################################################
# ## Print the fitting parameters with their errors ##
# ####################################################
print("-------------Lorentzian Fit-------------")
# print("Amplitude = %0.2f (+/-) %0.2f"' Cps' % (pars[0], perr_lorentz[0]))
# print("Center = %0.6f (+/-) %0.6f" ' THz'% (pars[1], perr_lorentz[1]))
# print("Width = %0.6f (+/-) %0.6f" ' THz'% (pars[2], perr_lorentz[2]))
print("--------------------------------")
print("HWHM_D1 = %0.6f " ' THz'% HWHM1)
print("FWHM_D1 = %0.6f " ' MHz'% FWHM1)
print("Center_$\sigma$- = %0.6f " ' THz'% Center1)
print("--------------------------------")
print("HWHM_D2 = %0.6f " ' THz'% HWHM2)
print("FWHM_D2 = %0.6f " ' MHz'% FWHM2)
print("Center_D2 = %0.6f " ' THz'% Center2)
print("--------------------------------")
print("HWHM_D3 = %0.6f " ' THz'% HWHM3)
print("FWHM_D3 = %0.6f " ' MHz'% FWHM3)
print("Center_D3 = %0.6f " ' THz'% Center3)
print("--------------------------------")
print("HWHM_D4 = %0.6f " ' THz'% HWHM4)
print("FWHM_D4 = %0.6f " ' MHz'% FWHM4)
print("Center_D4 = %0.6f " ' THz'% Center4)
print("--------------------------------")
print("HWHM_D5 = %0.6f " ' THz'% HWHM_5)
print("FWHM_D5 = %0.6f " ' MHz'% FWHM_5)
print("Center_D5 = %0.6f " ' THz'% Center_5)
print("--------------------------------")
print("HWHM_D6 = %0.6f " ' THz'% HWHM_6)
print("FWHM_D6 = %0.6f " ' MHz'% FWHM_6)
print("Center_D6 = %0.6f " ' THz'% Center_6)
print("--------------------------------")

#print(min(Center1,Center2,Center3,Center4,Center_5,Center_6))
print("Max Splitting = %0.6f " ' MHz'% Max_Splitting)


# ###########################
# # Plot the data & Labels ##
# ###########################
plt.plot(x_range_1,_1Lorentzian_1(x_range_1,*popt_lorentzian_1),'--',color='royalblue')#, label='Lorentzian fit') #+str(popt_lorentzian))
plt.plot(x_range_2,_1Lorentzian_2(x_range_2,*popt_lorentzian_2),'--',color='navy')#, label='Lorentzian fit') #+str(popt_lorentzian))
plt.plot(x_range_3,_1Lorentzian_3(x_range_3,*popt_lorentzian_3),'--',color='orange')#, label='Lorentzian fit') #+str(popt_lorentzian))
plt.plot(x_range_4,_1Lorentzian_4(x_range_4,*popt_lorentzian_4),'--',color='limegreen')#, label='Lorentzian fit') #+str(popt_lorentzian))
plt.plot(x_range_5,_1Lorentzian_5(x_range_5,*popt_lorentzian_5),'--',color='red')#, label='Lorentzian fit') #+str(popt_lorentzian))
plt.plot(x_range_6,_1Lorentzian_6(x_range_6,*popt_lorentzian_6),'--',color='brown')#, label='Lorentzian fit') #+str(popt_lorentzian))


### Write Fitting Params on the graph
#plt.plot(x2,_decay(x2,*popt_decay),'--',color='orange', label='Fit. func: $f(x) = %.f * e^{%.3f x} %+.3f$' % (A_opt,-t_opt,b_opt)) #+str(popt_lorentzian))
plt.text(234.4223, 100, f"\nFWHM_D1 = {FWHM1} $\pm$ {FWHM_err1} MHz" + \
                        f"\nCenter_D1 = {Center1} $\pm$ {Center_err1} THz"
                        f"\n" +\
                        f"\nFWHM_D2 = {FWHM2} $\pm$ {FWHM_err2} MHz" + \
                        f"\nCenter_D2 = {Center2} $\pm$ {Center_err2} THz"
                        f"\n" +\
                        f"\nFWHM_D3 = {FWHM3} $\pm$ {FWHM_err3} MHz" + \
                        f"\nCenter_D3 = {Center3} $\pm$ {Center_err3} THz"      
                        f"\n" +\
                        f"\nFWHM_D4 = {FWHM4} $\pm$ {FWHM_err4} MHz" + \
                        f"\nCenter_D2 = {Center4} $\pm$ {Center_err4} THz"
                        f"\n" +\
                        f"\nFWHM_D5 = {FWHM_5} $\pm$ {FWHM_err_5} MHz" + \
                        f"\nCenter_D5 = {Center_5} $\pm$ {Center_err_5} THz"
                        f"\n" +\
                        f"\nFWHM_D6 = {FWHM_6} $\pm$ {FWHM_err_6} MHz" + \
                        f"\nCenter_D6 = {Center_6} $\pm$ {Center_err_6} THz"
                        f"\n" + \
                        f"\nMax Splitting = {Max_Splitting} MHz"
                        ,fontsize=8) ## Text inside the plot

#plt.style.use('classic')
plt.ylim(ymin=0.0, ymax=270)
plt.xlim(xmin=234.42217, xmax=234.42918)
plt.rc('font', family='sans-serif')
plt.rc('font', serif='Helvetica')
plt.legend(prop={'size': 16}) #loc=2
plt.title('All $\sigma_+$ Defects')
plt.xlabel('Frequency (THz)', fontsize=16)
plt.ylabel(r'Intensity (Counts/s) ', fontsize=16) #($cps $)
plt.xticks(fontsize = 16)
plt.yticks(fontsize = 16)
plt.show()

